> ## Documentation Index
> Fetch the complete documentation index at: https://docs.firedrill.run/llms.txt
> Use this file to discover all available pages before exploring further.

# Read a compiler-validated source proposal



## OpenAPI

````yaml /api-reference/openapi.json get /v1/projects/{projectId}/authoring-sessions/{authoringSessionId}/proposals/{authoringProposalId}
openapi: 3.1.0
info:
  title: Firedrill Control API
  version: 1.0.0
  description: >-
    The control plane for drills, drill runs, and the worlds they run in. Errors
    always carry the canonical envelope; unsafe operations require an
    Idempotency-Key; long work returns an operation resource.
servers:
  - url: https://api.firedrill.run
security:
  - controlCredential: []
tags:
  - name: authentication
    description: Sessions, CLI exchange, credentials, and verification keys.
    x-group: Authentication
  - name: organizations
    description: Organization members, billing, usage, retention, audit, and exports.
    x-group: Organizations
  - name: projects
    description: Project lifecycle, access, grants, and repository bindings.
    x-group: Projects
  - name: builds
    description: Immutable builds, uploads, source drafts, and world definitions.
    x-group: Builds and source
  - name: tools
    description: Project Tool discovery, approval, source, and revocation.
    x-group: Tool library
  - name: worlds
    description: >-
      Managed environments, world sessions, state, time, reset, faults, forks,
      and snapshots.
    x-group: Environments and sessions
  - name: runs
    description: >-
      Hosted runs, comparisons, attachments, reports, evidence bundles, sharing,
      and exports.
    x-group: Runs and evidence
  - name: browser
    description: Managed browser tests, runs, messages, streams, frames, and artifacts.
    x-group: Browser testing
  - name: callbacks
    description: Callback receiver approval, revocation, and signing material.
    x-group: Callbacks
  - name: github-ci
    description: >-
      GitHub installations, repository automation, CI suites, cases, evidence,
      and checks.
    x-group: GitHub and CI
  - name: authoring
    description: Authoring sessions, proposals, turns, and scenario proposals.
    x-group: Cloud authoring
paths:
  /v1/projects/{projectId}/authoring-sessions/{authoringSessionId}/proposals/{authoringProposalId}:
    get:
      tags:
        - authoring
      summary: Read a compiler-validated source proposal
      operationId: authoring.getProposal
      parameters:
        - name: projectId
          in: path
          required: true
          schema:
            type: string
            pattern: ^prj_[0-9a-z]{12,32}$
        - name: authoringSessionId
          in: path
          required: true
          schema:
            type: string
            pattern: ^authsess_[0-9a-z]{12,32}$
        - name: authoringProposalId
          in: path
          required: true
          schema:
            type: string
            pattern: ^aprop_[0-9a-z]{12,32}$
      responses:
        '200':
          description: Read a compiler-validated source proposal
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/AuthoringProposal'
        default:
          description: Canonical error envelope
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorEnvelope'
components:
  schemas:
    AuthoringProposal:
      oneOf:
        - type: object
          properties:
            schemaVersion:
              type: number
              enum:
                - 1
            authoringProposalId:
              type: string
              pattern: ^aprop_[0-9a-z]{12,32}$
            authoringSessionId:
              type: string
              pattern: ^authsess_[0-9a-z]{12,32}$
            organizationId:
              type: string
              pattern: ^org_[0-9a-z]{12,32}$
            projectId:
              type: string
              pattern: ^prj_[0-9a-z]{12,32}$
            baseRevision:
              type: string
              pattern: ^[0-9a-f]{40}$
            state:
              type: string
              enum:
                - ready
                - publishing
                - published
                - discarded
                - superseded
            artifactDigest:
              type: string
              pattern: ^sha256:[0-9a-f]{64}$
            changedFiles:
              minItems: 1
              maxItems: 200
              type: array
              items:
                type: object
                properties:
                  path:
                    type: string
                    minLength: 1
                    maxLength: 1024
                  change:
                    type: string
                    enum:
                      - added
                      - modified
                      - deleted
                  beforeDigest:
                    type: string
                    pattern: ^sha256:[0-9a-f]{64}$
                  afterDigest:
                    type: string
                    pattern: ^sha256:[0-9a-f]{64}$
                  afterBytes:
                    type: integer
                    minimum: 0
                    maximum: 2097152
                required:
                  - path
                  - change
                additionalProperties: false
            buildHash:
              type: string
              pattern: ^sha256:[0-9a-f]{64}$
            diagnostics:
              maxItems: 2000
              type: array
              items:
                type: object
                properties:
                  code:
                    type: string
                    pattern: ^FD\d{4}$
                  severity:
                    type: string
                    enum:
                      - error
                      - warning
                      - info
                  message:
                    type: string
                    minLength: 1
                    maxLength: 2000
                  span:
                    type: object
                    properties:
                      path:
                        type: string
                        minLength: 1
                        maxLength: 1024
                      start:
                        type: object
                        properties:
                          line:
                            type: integer
                            minimum: 0
                            exclusiveMinimum: true
                            maximum: 9007199254740991
                          column:
                            type: integer
                            minimum: 0
                            exclusiveMinimum: true
                            maximum: 9007199254740991
                        required:
                          - line
                          - column
                        additionalProperties: false
                      end:
                        type: object
                        properties:
                          line:
                            type: integer
                            minimum: 0
                            exclusiveMinimum: true
                            maximum: 9007199254740991
                          column:
                            type: integer
                            minimum: 0
                            exclusiveMinimum: true
                            maximum: 9007199254740991
                        required:
                          - line
                          - column
                        additionalProperties: false
                    required:
                      - path
                      - start
                      - end
                    additionalProperties: false
                  path:
                    type: array
                    items:
                      anyOf:
                        - type: string
                        - type: integer
                          minimum: 0
                          maximum: 9007199254740991
                  suggestion:
                    type: string
                    minLength: 1
                    maxLength: 4000
                  data:
                    type: object
                    additionalProperties:
                      $ref: '#/components/schemas/AuthoringProposal___schema0'
                required:
                  - code
                  - severity
                  - message
                additionalProperties: {}
            pullRequestNumber:
              type: integer
              minimum: 0
              exclusiveMinimum: true
              maximum: 9007199254740991
            pullRequestUrl:
              type: string
              maxLength: 4096
              format: uri
            publishedRevision:
              type: string
              pattern: ^[0-9a-f]{40}$
            version:
              type: integer
              minimum: -9007199254740991
              maximum: 9007199254740991
            createdAtMs:
              type: integer
              minimum: -9007199254740991
              maximum: 9007199254740991
            updatedAtMs:
              type: integer
              minimum: -9007199254740991
              maximum: 9007199254740991
            publishedAtMs:
              type: integer
              minimum: -9007199254740991
              maximum: 9007199254740991
            source:
              default: agent
              type: string
              enum:
                - agent
            authoringTurnId:
              type: string
              pattern: ^aturn_[0-9a-z]{12,32}$
          required:
            - schemaVersion
            - authoringProposalId
            - authoringSessionId
            - organizationId
            - projectId
            - baseRevision
            - state
            - artifactDigest
            - changedFiles
            - buildHash
            - diagnostics
            - version
            - createdAtMs
            - updatedAtMs
            - source
            - authoringTurnId
          additionalProperties: false
        - type: object
          properties:
            schemaVersion:
              type: number
              enum:
                - 1
            authoringProposalId:
              type: string
              pattern: ^aprop_[0-9a-z]{12,32}$
            authoringSessionId:
              type: string
              pattern: ^authsess_[0-9a-z]{12,32}$
            organizationId:
              type: string
              pattern: ^org_[0-9a-z]{12,32}$
            projectId:
              type: string
              pattern: ^prj_[0-9a-z]{12,32}$
            baseRevision:
              type: string
              pattern: ^[0-9a-f]{40}$
            state:
              type: string
              enum:
                - ready
                - publishing
                - published
                - discarded
                - superseded
            artifactDigest:
              type: string
              pattern: ^sha256:[0-9a-f]{64}$
            changedFiles:
              minItems: 1
              maxItems: 200
              type: array
              items:
                type: object
                properties:
                  path:
                    type: string
                    minLength: 1
                    maxLength: 1024
                  change:
                    type: string
                    enum:
                      - added
                      - modified
                      - deleted
                  beforeDigest:
                    type: string
                    pattern: ^sha256:[0-9a-f]{64}$
                  afterDigest:
                    type: string
                    pattern: ^sha256:[0-9a-f]{64}$
                  afterBytes:
                    type: integer
                    minimum: 0
                    maximum: 2097152
                required:
                  - path
                  - change
                additionalProperties: false
            buildHash:
              type: string
              pattern: ^sha256:[0-9a-f]{64}$
            diagnostics:
              maxItems: 2000
              type: array
              items:
                type: object
                properties:
                  code:
                    type: string
                    pattern: ^FD\d{4}$
                  severity:
                    type: string
                    enum:
                      - error
                      - warning
                      - info
                  message:
                    type: string
                    minLength: 1
                    maxLength: 2000
                  span:
                    type: object
                    properties:
                      path:
                        type: string
                        minLength: 1
                        maxLength: 1024
                      start:
                        type: object
                        properties:
                          line:
                            type: integer
                            minimum: 0
                            exclusiveMinimum: true
                            maximum: 9007199254740991
                          column:
                            type: integer
                            minimum: 0
                            exclusiveMinimum: true
                            maximum: 9007199254740991
                        required:
                          - line
                          - column
                        additionalProperties: false
                      end:
                        type: object
                        properties:
                          line:
                            type: integer
                            minimum: 0
                            exclusiveMinimum: true
                            maximum: 9007199254740991
                          column:
                            type: integer
                            minimum: 0
                            exclusiveMinimum: true
                            maximum: 9007199254740991
                        required:
                          - line
                          - column
                        additionalProperties: false
                    required:
                      - path
                      - start
                      - end
                    additionalProperties: false
                  path:
                    type: array
                    items:
                      anyOf:
                        - type: string
                        - type: integer
                          minimum: 0
                          maximum: 9007199254740991
                  suggestion:
                    type: string
                    minLength: 1
                    maxLength: 4000
                  data:
                    type: object
                    additionalProperties:
                      $ref: '#/components/schemas/AuthoringProposal___schema0'
                required:
                  - code
                  - severity
                  - message
                additionalProperties: {}
            pullRequestNumber:
              type: integer
              minimum: 0
              exclusiveMinimum: true
              maximum: 9007199254740991
            pullRequestUrl:
              type: string
              maxLength: 4096
              format: uri
            publishedRevision:
              type: string
              pattern: ^[0-9a-f]{40}$
            version:
              type: integer
              minimum: -9007199254740991
              maximum: 9007199254740991
            createdAtMs:
              type: integer
              minimum: -9007199254740991
              maximum: 9007199254740991
            updatedAtMs:
              type: integer
              minimum: -9007199254740991
              maximum: 9007199254740991
            publishedAtMs:
              type: integer
              minimum: -9007199254740991
              maximum: 9007199254740991
            source:
              type: string
              enum:
                - scenario
          required:
            - schemaVersion
            - authoringProposalId
            - authoringSessionId
            - organizationId
            - projectId
            - baseRevision
            - state
            - artifactDigest
            - changedFiles
            - buildHash
            - diagnostics
            - version
            - createdAtMs
            - updatedAtMs
            - source
          additionalProperties: false
    ErrorEnvelope:
      type: object
      properties:
        code:
          type: string
          pattern: ^(control|world)\.[A-Z][A-Z0-9]*(_[A-Z0-9]+)*$
        message:
          type: string
          minLength: 1
        correlationId:
          type: string
          minLength: 1
        retryable:
          type: boolean
        retryAfterMs:
          type: integer
          exclusiveMinimum: 0
          maximum: 9007199254740991
        operationId:
          type: string
        source:
          type: string
          enum:
            - platform
            - simulated_provider
        issues:
          type: array
          items:
            type: object
            properties:
              path:
                type: string
              code:
                type: string
              message:
                type: string
            required:
              - path
              - code
              - message
            additionalProperties: false
        details:
          type: object
          propertyNames:
            type: string
          additionalProperties: {}
        evidence:
          type: object
          properties:
            sessionId:
              type: string
            runId:
              type: string
            journalSeq:
              type: integer
              minimum: 0
              maximum: 9007199254740991
            buildHash:
              type: string
          additionalProperties: false
      required:
        - code
        - message
        - correlationId
        - retryable
        - source
      additionalProperties: true
    AuthoringProposal___schema0:
      description: Any JSON-compatible value
  securitySchemes:
    controlCredential:
      type: http
      scheme: bearer
      description: Opaque control credential

````